mod Ex09b

incl Mtex

incl Mtexrc

loc rem 
  \para \bf  9. CVICENIE Z PREDMETU 1-AIN-625 UVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 23.11.2010 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1011zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane obecne rekurzivnym 
  fukciam. Zadanie sa sklada z tychto suborov: z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
   \item \para Subor \it  msyntax.cl  \end obsahuje syntax systemu CL. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 1 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 0 
  \end
  \para Odovzdat do 6.12.2010 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. General Recursive Functions.  \end See [1]. 

rem 
  \para \bf  Section. General Recursive Functions.  \end 

rem 
  \para \bf  Definition.  \end General recursive functions is the smallest class 
  of functions containing the successor \ft x+1 \end and predecessor 
  \ft x-1 \end functions, and is closed under regular recursive definitions 
  (note that this includes explicit definitions). 

rem 
  \para \bf  Theorem.  \end The class of general recursive functions is 
  primitively recursively closed. 

rem 
  \para \bf  Corollary.  \end We have 
  \items 
   \item \para every primitive recursive function and predicate is general 
         recursive, 
   \item \para general recursive functions are closed under bounded 
         minimalization, 
   \item \para general recursive predicates are closed under explicit 
         definitions of predicates with bounded formulas, 
   \item \para general recursive functions and predicates are closed under 
         regular recursive definitions in clausal form. 
  \end

rem 
  \para \bf  Subsection. Regular Minimalization.  \end 

rem 
  \para \bf  Operator of regular minimalization.  \end 

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Show that general recursive 
  functions are closed under the operator of regular minimalization. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Operator_of_regular_minimalization

fun/2 G 'Tex_f2_g'

rem 
  \para \header* fun F 'Tex_f1_f' \end Show that if \ft G(y,x) \end is a general 
  recursive function such that 
  \eq* 
    \a x\e y G(y,x) = 1
  \end
  \para then so is the function \ft F(x) \end defined by regular minimalization: 

fun F 'Tex_f1_f'
  F(x) = \m y [ G(y,x) = 1 ]

rem 
  \para \it  Proof.  \end 

fun F_is_grec 'Tex_f1_f'
  F_is_grec(x) = Foo

end theory Operator_of_regular_minimalization

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation. 

rem 
  \para \bf  Theorem.  \end General recursive functions are closed under the 
  operator of regular minimalization. 

rem 
  \para \bf  Definitions of functions with regular minimalization.  \end 

rem 
  \para \bf  [CL] Syntax.  \end \header* pred/2 R  \end Example(s): 
  \def 
    fun F 'Tex_f1_f'
    F(x) = \m y [ R(x,y) ]
  \end
  \para provided the following condition of regularity is satisfied: 
  \eq* 
    \a x\e yR(x,y)
  \end

rem 
  \para \bf  Theorem.  \end General recursive functions are closed under 
  definitions of functions with regular minimalization. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

